using FluentValidation;
using CMSMicroservice.Protobuf.Protos.FactorDetails;
namespace CMSMicroservice.Protobuf.Validator.FactorDetails;

public class DeleteFactorDetailsRequestValidator : AbstractValidator<DeleteFactorDetailsRequest>
{
    public DeleteFactorDetailsRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<DeleteFactorDetailsRequest>.CreateWithOptions((DeleteFactorDetailsRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
